Subject: bug#78649: closed ((recursive? #t) doesn't seem to be part of the source hash)

From: [email-masked] (GNU bug Tracking System)
Date: Sat, 26 Jul 2025 12:27:02 +0000

Your message dated Sat, 26 Jul 2025 21:25:51 +0900
with message-id <[email-masked]>
and subject line Re: bug#78649: (recursive? #t) doesn't seem to be part of the source hash
has caused the debbugs.gnu.org bug report #78649,
regarding (recursive? #t) doesn't seem to be part of the source hash
to be marked as done.

(If you believe you have received this mail in error, please contact
[email-masked].)

-- 
78649: https://debbugs.gnu.org/cgi/bugreport.cgi?bug=78649
GNU Bug Tracking System
Contact [email-masked] with problems

Subject: (recursive? #t) doesn't seem to be part of the source hash
From: "nomike (they/them)" <[email-masked]>
To: [email-masked]
Date: Sat, 31 May 2025 00:56:03 +0200
List-Id: <debbugs-submit.debbugs.gnu.org>

Hi!

I'm currently working on a package definition and again stumbled upon an 
issue:

I had the flag `(recursive? #t)` added to `source`:

```scheme
       (source
        (origin
          (method git-fetch)
          (uri (git-reference
                (url "https://github.com/openscad/openscad")
                (commit commit)
                (recursive? #t)))
          (sha256
           (base32 "1bkzrjjp0qvfg7pj24j5pa0i6zj0zsqjb5z4w3l6pjdb5q9in0qi"))
          (file-name (git-file-name name version))))
```

I then removed the recursive flag and continued on working on my 
package, which is based on a commit-ID of the upstream project. Once I 
switched to a newer commit, I got strange build errors from cmake. I 
switched back the original commit, everything worked again.
It took me a while to remember, that in such a case, guix is not 
re-downloading the source as the source hash doesn't change.

IMHO this hash should also contain flags like recursive.

When  `git clone foo` is changed to `git clone --recursive foo` the 
source has obviously changed (unless the repo doesn't have submodules 
perhaps), so it doesn't make sense that the sha256 hash stays the same.

Is this something we can address?

Or is this an issue as it would invalidate all current source hashes at 
once?

Thanks

nomike

Subject: Re: bug#78649: (recursive? #t) doesn't seem to be part of the source hash
From: Maxim Cournoyer <[email-masked]>
To: Simon Tournier <[email-masked]>
Cc: [email-masked], "nomike \(they/them\)" <[email-masked]>
Date: Sat, 26 Jul 2025 21:25:51 +0900
List-Id: <debbugs-submit.debbugs.gnu.org>

Hi,

Thoroughly answered by Simon :-).

Closing.

-- 
Thanks,
Maxim